/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2016 - 2020 Balthasar Weitzel, Steffen Hupp
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.api.logistics;

import static org.hamcrest.Matchers.hasSize;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import java.util.Arrays;
import java.util.UUID;

import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.web.servlet.MvcResult;

import de.fhg.iese.dd.platform.api.BaseServiceTest;
import de.fhg.iese.dd.platform.api.BaseTestHelper;
import de.fhg.iese.dd.platform.api.communication.clientmodel.ClientChatMessage;
import de.fhg.iese.dd.platform.api.logistics.clientevent.ClientDeliveryCreatedEvent;
import de.fhg.iese.dd.platform.api.logistics.clientevent.ClientTransportAlternativeSelectRequest;
import de.fhg.iese.dd.platform.api.logistics.clientevent.ClientTransportAlternativeSelectResponse;
import de.fhg.iese.dd.platform.api.logistics.clientmodel.ClientDimension;
import de.fhg.iese.dd.platform.api.shared.address.clientmodel.ClientAddressDefinition;
import de.fhg.iese.dd.platform.api.shopping.clientevent.ClientPurchaseOrderReadyForTransportRequest;
import de.fhg.iese.dd.platform.api.shopping.clientevent.ClientPurchaseOrderReceivedEvent;
import de.fhg.iese.dd.platform.api.shopping.clientmodel.ClientPurchaseOrderItem;
import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.framework.exceptions.ClientExceptionType;
import de.fhg.iese.dd.platform.datamanagement.logistics.model.TransportAlternative;
import de.fhg.iese.dd.platform.datamanagement.logistics.model.enums.DimensionCategory;
import de.fhg.iese.dd.platform.datamanagement.logistics.model.enums.PackagingType;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;
import de.fhg.iese.dd.platform.datamanagement.participants.shop.model.Shop;
import de.fhg.iese.dd.platform.datamanagement.shared.misc.model.TimeSpan;

public class LogisticsChatControllerTest extends BaseServiceTest {

    @Autowired
    private LogisticsTestHelper th;

    @Override
    public void createEntities() throws Exception {

        thStatic = th;
        if(firstRun){
            th.createTenantsAndGeoAreas();
            th.createPushEntities();
            th.createPersons();
            th.createScoreEntities();
            th.createShops();
            th.createPoolingStations();
            th.createAchievementRules();
            th.createBestellBarAppAndAppVariants();

            init();
            firstRun = false;
        }
    }

    @Override
    public void tearDown() throws Exception {

        //set the last message to null to avoid constraint violation
        th.chatRepository.findAll()
                .forEach((Chat chat) -> {
                    chat.setLastMessageNotAutoGenerated(null);
                    th.chatRepository.saveAndFlush(chat);
                });
        th.chatMessageRepository.deleteAllInBatch();
        //refresh the chats to remove inconsistencies due to illegal message deletion
        th.chatRepository.findAll()
                .forEach(chat -> th.chatService.updateLastMessageAndUnreadMessageCount(chat, false));
    }

    protected static Person receiver;

    protected static Person carrier;

    protected static String transportAssignmentId;

    protected static String deliveryId;

    private static boolean firstRun = true;

    protected static BaseTestHelper thStatic;

    @AfterAll
    public static void tearDownAll() {
        thStatic.deleteAllData();
    }

    private void init() throws Exception {
        receiver = th.personVgAdmin;
        carrier = th.personPoolingStationOp;
        Shop sender = th.shop1;

        // PurchaseOrderReceived
        ClientPurchaseOrderReceivedEvent purchaseOrderReceivedEvent = ClientPurchaseOrderReceivedEvent.builder()
                .shopOrderId("shopOrderId" + UUID.randomUUID())
                .communityId(th.tenant1.getId())
                .senderShopId(sender.getId())
                .purchaseOrderNotes("purchaseOrderNotes" + UUID.randomUUID())
                .pickupAddress(ClientAddressDefinition.builder()
                        .name("Fraunhofer IESE")
                        .street("Fraunhofer-Platz 1")
                        .zip("67663")
                        .city("Kaiserslautern")
                        .build())
                .receiverPersonId(receiver.getId())
                .deliveryAddress(ClientAddressDefinition.builder()
                        .name("Balthasar Weitzel")
                        .street("Pfaffenbärstraße 42")
                        .zip("67663")
                        .city("Kaiserslautern")
                        .build())
                .transportNotes("transportNotes" + UUID.randomUUID())
                .orderedItems(Arrays.asList(
                        new ClientPurchaseOrderItem(2, "item", "unit"),
                        new ClientPurchaseOrderItem(42, "Straußeneier", "große Stücke")))
                .desiredDeliveryTime(
                        new TimeSpan(System.currentTimeMillis(), System.currentTimeMillis() + 1000 * 60 * 60 * 3))
                .deliveryPoolingStationId("")
                .credits(0)
                .build();

        MvcResult response = mockMvc.perform(post("/shopping/event/purchaseorderreceived")
                .header(HEADER_NAME_API_KEY, th.appVariantBestellBar1.getApiKey1())
            .contentType(contentType)
            .content(json(purchaseOrderReceivedEvent)))
            .andExpect(status().isOk()).andReturn();

        ClientDeliveryCreatedEvent deliveryCreatedEvent = toObject(response.getResponse(), ClientDeliveryCreatedEvent.class);
        deliveryId = deliveryCreatedEvent.getDeliveryId();

        // PurchaseOrderReadyForTransport
        ClientPurchaseOrderReadyForTransportRequest purchaseOrderReadyForTransportRequest =
                ClientPurchaseOrderReadyForTransportRequest.builder()
                        .shopOrderId(purchaseOrderReceivedEvent.getShopOrderId())
                        .size(ClientDimension.builder()
                                .length(40.0)
                                .width(30.0)
                                .height(20.0)
                                .category(DimensionCategory.M)
                                .weight(0.7)
                                .build())
                        .contentNotes("contentNotes")
                        .packagingType(PackagingType.PARCEL)
                        .numParcels(1)
                        .build();

        mockMvc.perform(post("/shopping/event/purchaseorderreadyfortransport")
                .header(HEADER_NAME_API_KEY, th.appVariantBestellBar1.getApiKey1())
            .contentType(contentType)
            .content(json(purchaseOrderReadyForTransportRequest)))
            .andExpect(status().isOk());

        TransportAlternative transportAlternative = th.transportAlternativeRepository.findAll().get(0);

        // TransportAlternativeSelectRequest
        ClientTransportAlternativeSelectRequest transportAlternativeSelectRequest = new ClientTransportAlternativeSelectRequest(
                transportAlternative.getId());

        response = mockMvc.perform(post("/logistics/event/transportAlternativeSelectRequest")
                        .headers(authHeadersFor(carrier))
                        .contentType(contentType)
                        .content(json(transportAlternativeSelectRequest)))
            .andExpect(status().isOk()).andReturn();

        ClientTransportAlternativeSelectResponse transportAlternativeSelectResponse = toObject(response.getResponse(),
                ClientTransportAlternativeSelectResponse.class);

        transportAssignmentId = transportAlternativeSelectResponse.getTransportAssignmentToLoadId();
    }

    private ClientChatMessage createClientChatMessage(Person person, String message, long timestamp) {
        return ClientChatMessage.builder()
                .id(UUID.randomUUID().toString())
                .senderId(person.getId())
                .senderFirstName(person.getFirstName())
                .senderFirstName(person.getLastName())
                .message(message)
                .sentTime(timestamp)
                .created(timestamp)
                .build();
    }

    @Test
    public void sendCarrierMessage() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(carrier, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/transport/" + transportAssignmentId + "/chat")
                        .headers(authHeadersFor(carrier))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
            .andExpect(status().isOk());
    }

    @Test
    public void sendCarrierMessageWithoutMessage() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(carrier, null, System.currentTimeMillis());

        mockMvc.perform(post("/logistics/transport/" + transportAssignmentId + "/chat")
                        .headers(authHeadersFor(carrier))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
                .andExpect(isException(ClientExceptionType.CHAT_MESSAGE_INVALID));
    }

    @Test
    public void sendCarrierMessageInvalidTransportAssignmentId() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(carrier, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/transport/" + UUID.randomUUID() + "/chat")
                        .headers(authHeadersFor(carrier))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
                .andExpect(isException(ClientExceptionType.TRANSPORT_ASSIGNMENT_NOT_FOUND));
    }

    @Test
    public void sendCarrierMessageUnauthorized() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(carrier, "Message", System.currentTimeMillis());

        assertOAuth2(post("/logistics/transport/" + transportAssignmentId + "/chat")
                .content(json(clientChatMessage))
                .contentType(contentType));
    }

    @Test
    public void sendReceiverMessage() throws Exception {
        //FIXME very weak test

        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/delivery/" + deliveryId + "/chat")
                        .headers(authHeadersFor(receiver))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
            .andExpect(status().isOk());
    }

    @Test
    public void sendReceiverMessageWithoutMessage() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, null, System.currentTimeMillis());

        mockMvc.perform(post("/logistics/delivery/" + deliveryId + "/chat")
                        .headers(authHeadersFor(receiver))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
                .andExpect(isException(ClientExceptionType.CHAT_MESSAGE_INVALID));
    }

    @Test
    public void sendReceiverMessageInvalidDeliveryId() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/delivery/" + UUID.randomUUID() + "/chat")
                        .headers(authHeadersFor(receiver))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
                .andExpect(isException(ClientExceptionType.DELIVERY_NOT_FOUND));
    }

    @Test
    public void sendReceiverMessageUnauthorized() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, "Message", System.currentTimeMillis());

        assertOAuth2(post("/logistics/delivery/" + deliveryId + "/chat")
                .content(json(clientChatMessage))
                .contentType(contentType));
    }

    @Test
    public void getMessagesDelivery() throws Exception {
        final String msg = "Message";
        final long timestamp = System.currentTimeMillis();

        ClientChatMessage clientChatMessage = createClientChatMessage(carrier, msg, timestamp);

        mockMvc.perform(post("/logistics/transport/" + transportAssignmentId + "/chat")
                        .headers(authHeadersFor(carrier))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
            .andExpect(status().isOk());

        mockMvc.perform(get("/logistics/delivery/"+deliveryId+"/chat")
            .headers(authHeadersFor(receiver))
            .param("from", "0"))
            .andExpect(status().isOk())
            .andExpect(jsonPath("$", hasSize(1)))
            .andExpect(jsonPath("$[0].senderId").value(carrier.getId()))
            .andExpect(jsonPath("$[0].senderFirstName").value(carrier.getFirstName()))
            .andExpect(jsonPath("$[0].senderLastName").value(carrier.getLastName()))
            .andExpect(jsonPath("$[0].message").value(msg))
            .andExpect(jsonPath("$[0].sentTime").value(timestamp));
    }

    @Test
    public void getMessagesDeliveryFrom() throws Exception {
        //FIXME very weak test

        ClientChatMessage clientChatMessage = createClientChatMessage(carrier, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/transport/" + transportAssignmentId + "/chat")
                        .headers(authHeadersFor(carrier))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
            .andExpect(status().isOk());

        mockMvc.perform(get("/logistics/delivery/"+deliveryId+"/chat")
            .headers(authHeadersFor(receiver))
            .param("from", "0"))
            .andExpect(status().isOk());
    }

    @Test
    public void getMessagesDeliveryUnauthorized() throws Exception {

        assertOAuth2(get("/logistics/delivery/" + deliveryId + "/chat")
                .param("from", "0"));
    }

    @Test
    public void getChatMessagesTransportAssignment() throws Exception {
        final String msg = UUID.randomUUID().toString();
        final long timestamp = System.currentTimeMillis();

        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, msg, timestamp);

        mockMvc.perform(post("/logistics/delivery/" + deliveryId + "/chat")
                        .headers(authHeadersFor(receiver))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
            .andExpect(status().isOk());

        mockMvc.perform(get("/logistics/transport/"+transportAssignmentId+"/chat")
            .headers(authHeadersFor(carrier))
            .param("from", "0"))
            .andExpect(status().isOk())
            .andExpect(jsonPath("$", hasSize(1)))
            .andExpect(jsonPath("$[0].senderId").value(receiver.getId()))
            .andExpect(jsonPath("$[0].senderFirstName").value(receiver.getFirstName()))
            .andExpect(jsonPath("$[0].senderLastName").value(receiver.getLastName()))
            .andExpect(jsonPath("$[0].message").value(msg))
            .andExpect(jsonPath("$[0].sentTime").value(timestamp));
    }

    @Test
    public void getChatMessagesTransportAssignmentFrom() throws Exception {
        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/delivery/" + deliveryId + "/chat")
                        .headers(authHeadersFor(receiver))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
            .andExpect(status().isOk());

        mockMvc.perform(get("/logistics/transport/"+transportAssignmentId+"/chat")
            .headers(authHeadersFor(carrier))
            .param("from", String.valueOf(System.currentTimeMillis())))
            .andExpect(status().isOk())
            .andExpect(jsonPath("$", hasSize(0)));
    }

    @Test
    public void getChatMessagesTransportAssignmentInvalidTransportAssignmentId() throws Exception {

        ClientChatMessage clientChatMessage = createClientChatMessage(receiver, "Message", System.currentTimeMillis());

        mockMvc.perform(post("/logistics/delivery/" + deliveryId + "/chat")
                        .headers(authHeadersFor(receiver))
                        .contentType(contentType)
                        .content(json(clientChatMessage)))
                .andExpect(status().isOk());

        mockMvc.perform(get("/logistics/transport/" + UUID.randomUUID() + "/chat")
                .headers(authHeadersFor(carrier))
                .param("from", "0"))
                .andExpect(isException(ClientExceptionType.TRANSPORT_ASSIGNMENT_NOT_FOUND));
    }

    @Test
    public void getChatMessagesTransportAssignmentUnauthorized() throws Exception {
        assertOAuth2(get("/logistics/transport/" + transportAssignmentId + "/chat")
                .param("from", "0"));
    }

}
